'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _bufObject = require('./buf-object');

var _bufObject2 = _interopRequireDefault(_bufObject);

var _objCount = require('./obj-count');

var _objCount2 = _interopRequireDefault(_objCount);

var _objStandardize = require('./obj-standardize');

var _objStandardize2 = _interopRequireDefault(_objStandardize);

var _objFlatten = require('./obj-flatten');

var _objFlatten2 = _interopRequireDefault(_objFlatten);

var _txtConcat = require('./txt-concat');

var _txtConcat2 = _interopRequireDefault(_txtConcat);

var _txtObject = require('./txt-object');

var _txtObject2 = _interopRequireDefault(_txtObject);

var _txtParse = require('./txt-parse');

var _txtParse2 = _interopRequireDefault(_txtParse);

var _xmlParse = require('./xml-parse');

var _xmlParse2 = _interopRequireDefault(_xmlParse);

var _csvParse = require('./csv-parse');

var _csvParse2 = _interopRequireDefault(_csvParse);

var _csvObject = require('./csv-object');

var _csvObject2 = _interopRequireDefault(_csvObject);

var _csvString = require('./csv-string');

var _csvString2 = _interopRequireDefault(_csvString);

var _skosObject = require('./skos-object');

var _skosObject2 = _interopRequireDefault(_skosObject);

var _jsonParse = require('./json-parse');

var _jsonParse2 = _interopRequireDefault(_jsonParse);

var _jsonString = require('./json-string');

var _jsonString2 = _interopRequireDefault(_jsonString);

var _urlFetch = require('./url-fetch');

var _urlFetch2 = _interopRequireDefault(_urlFetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    BUFObject: _bufObject2.default,
    OBJCount: _objCount2.default,
    OBJStandardize: _objStandardize2.default,
    OBJFlatten: _objFlatten2.default,
    TXTParse: _txtParse2.default,
    TXTObject: _txtObject2.default,
    TXTConcat: _txtConcat2.default,
    XMLParse: _xmlParse2.default,
    CSVParse: _csvParse2.default,
    CSVObject: _csvObject2.default,
    CSVString: _csvString2.default,
    SKOSObject: _skosObject2.default,
    JSONParse: _jsonParse2.default,
    JSONString: _jsonString2.default,
    URLFetch: _urlFetch2.default,
    // aliases
    bufferify: _bufObject2.default.BUFObject,
    jsonify: _jsonString2.default.JSONString,
    flatten: _objFlatten2.default.OBJFlatten,
    concat: _txtConcat2.default.TXTConcat,
    standardize: _objStandardize2.default.OBJStandardize,
    split: _txtParse2.default.TXTParse,
    segmenter: _txtParse2.default.TXTParse
};