'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _ezs = require('ezs');

var _ezs2 = _interopRequireDefault(_ezs);

var _tmpFilepath = require('tmp-filepath');

var _tmpFilepath2 = _interopRequireDefault(_tmpFilepath);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _txtParse = require('./txt-parse');

var _txtParse2 = _interopRequireDefault(_txtParse);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function serializeObjects(data2, feed2) {
    if (!this.isLast()) {
        var buf = new Buffer(data2, 'base64');
        feed2.send(JSON.parse(buf.toString()));
    } else {
        feed2.close();
    }
}

function OBJStandardize(data1, feed1) {
    var self = this;
    if (!self.tmpFile) {
        self.tmpFile = (0, _tmpFilepath2.default)('.bin');
        self.struct = [];
        self.tmpStream = _fs2.default.createWriteStream(self.tmpFile);
    }

    if (self.isLast()) {
        _fs2.default.createReadStream(self.tmpFile).pipe((0, _ezs2.default)(_txtParse2.default, { separator: '\n' })).pipe((0, _ezs2.default)(serializeObjects)).pipe((0, _ezs2.default)(function unserializeObjects(data3, feed3) {
            if (this.isLast()) {
                _fs2.default.unlink(self.tmpFile, function () {
                    return feed1.close();
                });
            } else {
                var vv = {};
                self.struct.forEach(function (k) {
                    if (!data3[k]) {
                        vv[k] = '';
                    } else {
                        vv[k] = data3[k];
                    }
                });
                feed1.write(vv);
            }
            feed3.end();
        }));
    } else {
        Object.keys(data1).forEach(function (k) {
            if (self.struct.indexOf(k) === -1) {
                self.struct.push(k);
            }
        });
        (0, _utils.writeTo)(self.tmpStream, new Buffer(JSON.stringify(data1)).toString('base64').concat('\n'), function () {
            return feed1.end();
        });
    }
}

/**
 * Take `Object` and standardize it so each object will have the sames keys
 *
 * @name OBJStandardize
 * @alias standardize
 * @param {undefined} none
 * @returns {Object}
 */
exports.default = {
    OBJStandardize: OBJStandardize
};