'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Commands = function () {
    function Commands(commands) {
        _classCallCheck(this, Commands);

        (0, _assert2.default)(Array.isArray(commands), 'Commands should be an array.');
        this.commands = commands;
        this.useCommands = this.commands.filter(function (c) {
            return c.name === 'use';
        });
    }

    _createClass(Commands, [{
        key: 'getUseCommands',
        value: function getUseCommands() {
            return this.useCommands;
        }
    }, {
        key: 'get',
        value: function get() {
            return this.commands;
        }
    }, {
        key: 'analyse',
        value: function analyse() {
            var _this = this;

            var newCmds = [];
            var first = true;
            var previousMode = '';
            this.commands.filter(function (c) {
                return c.name !== 'use';
            }).forEach(function (c) {
                var currentMode = c.mode === 'divisible' ? 'dispatch' : 'pipeline';
                if (currentMode !== previousMode) {
                    if (currentMode === 'dispatch' || first) {
                        newCmds.push({
                            func: currentMode,
                            cmds: [].concat(_toConsumableArray(_this.useCommands), [c])
                        });
                    } else {
                        newCmds.push({
                            func: currentMode,
                            cmds: [c]
                        });
                    }
                } else {
                    var idx = newCmds.length - 1;
                    newCmds[idx].cmds.push(c);
                }
                previousMode = currentMode;
                first = false;
            });
            return newCmds;
        }
    }]);

    return Commands;
}();

exports.default = Commands;