'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _stream = require('stream');

var _parameter = require('./parameter');

var _parameter2 = _interopRequireDefault(_parameter);

var _feed = require('./feed');

var _feed2 = _interopRequireDefault(_feed);

var _shell = require('./shell');

var _shell2 = _interopRequireDefault(_shell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function createErrorWith(error, index) {
    var stk = error.stack.split('\n');
    var erm = stk.shift();
    var msg = 'Processing item #' + index + ' failed with ' + erm + '\n\t' + stk.slice(0, 10).join('\n\t');
    var err = Error(msg);
    Error.captureStackTrace(err, createErrorWith);
    if (process.env.NODE_ENV !== 'production') {
        console.error('ezs caught an', err);
    }
    return err;
}

var Engine = function (_Transform) {
    _inherits(Engine, _Transform);

    function Engine(ezs, func, params, selector) {
        _classCallCheck(this, Engine);

        var _this = _possibleConstructorReturn(this, (Engine.__proto__ || Object.getPrototypeOf(Engine)).call(this, { objectMode: true }));

        _this.func = func;
        _this.funcName = String(func.name);
        _this.index = 0;
        _this.selector = selector;
        _this.params = params || {};
        _this.scope = {};
        _this.ezs = ezs;
        return _this;
    }

    _createClass(Engine, [{
        key: '_transform',
        value: function _transform(chunk, encoding, done) {
            this.index += 1;
            if (chunk instanceof Error) {
                this.push(chunk);
                done();
            } else if (this.selector && _lodash2.default.has(chunk, this.selector)) {
                this.execWith(chunk, done);
            } else if (this.selector && !_lodash2.default.has(chunk, this.selector)) {
                this.push(chunk);
                done();
            } else {
                this.execWith(chunk, done);
            }
        }
    }, {
        key: '_flush',
        value: function _flush(done) {
            this.execWith(null, done);
        }
    }, {
        key: 'execWith',
        value: function execWith(chunk, done) {
            var _this2 = this;

            var push = function push(data) {
                if (data instanceof Error) {
                    return _this2.push(createErrorWith(data, _this2.index));
                }
                return _this2.push(data);
            };
            var feed = new _feed2.default(push, done);
            this.scope.isFirst = function () {
                return _this2.index === 1;
            };
            this.scope.getIndex = function () {
                return _this2.index;
            };
            this.scope.isLast = function () {
                return chunk === null;
            };
            this.scope.getParams = function () {
                return _this2.params;
            };
            this.scope.ezs = this.ezs;

            try {
                this.scope.getParam = function (name, defval) {
                    var globalParams = _parameter2.default.get(_this2.ezs, _this2.funcName);
                    if (_this2.params[name] !== undefined) {
                        return (0, _shell2.default)(_this2.params[name], chunk);
                    } else if (globalParams[name] !== undefined) {
                        return globalParams[name];
                    }
                    return defval;
                };
                this.func.call(this.scope, chunk, feed);
            } catch (e) {
                this.push(createErrorWith(e, this.index));
                done();
            }
        }
    }]);

    return Engine;
}(_stream.Transform);

exports.default = Engine;
