'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _stream = require('stream');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var reducer = function reducer(ezs) {
    return function (stream, command) {
        return stream.pipe(ezs(command.name, command.args));
    };
};

var Global = function (_Transform) {
    _inherits(Global, _Transform);

    function Global(ezs, commands, options) {
        _classCallCheck(this, Global);

        var _this = _possibleConstructorReturn(this, (Global.__proto__ || Object.getPrototypeOf(Global)).call(this, _extends({}, options, { objectMode: true })));

        _this.first = true;
        _this.tubin = new _stream.PassThrough({ objectMode: true });
        _this.tubout = _this.tubin;
        if (Array.isArray(commands)) {
            _this.tubout = commands.reduce(reducer(ezs), _this.tubout);
        }
        _this.on('finish', function () {
            _this.tubin.end();
        });
        _this.on('close', function () {
            _this.tubin.close();
        });
        _this.tubout.pause();
        _this.globals = null;
        return _this;
    }

    _createClass(Global, [{
        key: '_transform',
        value: function _transform(chunk, encoding, callback) {
            var _this2 = this;

            if (this.first === true) {
                this.first = false;

                this.tubout.on('data', function (chunk2) {
                    if ((typeof chunk2 === 'undefined' ? 'undefined' : _typeof(chunk2)) === 'object') {
                        if (!_this2.globals) {
                            _this2.globals = {};
                        }
                        _this2.globals = Object.assign(_this2.globals, chunk2);
                    } else {
                        if (!_this2.globals) {
                            _this2.globals = '';
                        }
                        _this2.globals += chunk2;
                    }
                }).on('end', function () {
                    var result = Object.assign(chunk, { $globals: _this2.globals });
                    callback(null, result);
                });
                this.tubout.resume();
                this.tubin.write(chunk, encoding, function () {
                    _this2.tubin.end();
                });
            } else {
                var result = Object.assign(chunk, { $globals: this.globals });
                callback(null, result);
            }
        }
    }]);

    return Global;
}(_stream.Transform);

exports.default = Global;