'use strict';

var _engine = require('./engine');

var _engine2 = _interopRequireDefault(_engine);

var _pipeline = require('./pipeline');

var _pipeline2 = _interopRequireDefault(_pipeline);

var _dispatch = require('./dispatch');

var _dispatch2 = _interopRequireDefault(_dispatch);

var _single = require('./single');

var _single2 = _interopRequireDefault(_single);

var _script = require('./script');

var _script2 = _interopRequireDefault(_script);

var _file = require('./file');

var _file2 = _interopRequireDefault(_file);

var _output = require('./output');

var _output2 = _interopRequireDefault(_output);

var _catcher = require('./catcher');

var _catcher2 = _interopRequireDefault(_catcher);

var _plugins = require('./plugins');

var _plugins2 = _interopRequireDefault(_plugins);

var _parameter = require('./parameter');

var _parameter2 = _interopRequireDefault(_parameter);

var _statement = require('./statement');

var _statement2 = _interopRequireDefault(_statement);

var _isolatedStore = require('./isolated-store');

var _isolatedStore2 = _interopRequireDefault(_isolatedStore);

var _sharedStore = require('./shared-store');

var _sharedStore2 = _interopRequireDefault(_sharedStore);

var _meta = require('./meta');

var _meta2 = _interopRequireDefault(_meta);

var _server = require('./server');

var _server2 = _interopRequireDefault(_server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ezs = function ezs(name, opts) {
    return new _engine2.default(ezs, _statement2.default.get(ezs, name, opts), opts);
};
var ezsPath = [process.cwd()];

ezs.config = function (name, opts) {
    return _parameter2.default.set(ezs, name, opts);
};
ezs.pipeline = function (commands, options) {
    return new _pipeline2.default(ezs, commands, options);
};
ezs.dispatch = function (commands, options) {
    return new _dispatch2.default(ezs, commands, options);
};
ezs.all = function (name, opts) {
    return new _engine2.default(ezs, _statement2.default.get(ezs, name, opts), opts);
};
ezs.single = function (mixed, options) {
    return new _single2.default(ezs, mixed, options);
};
ezs.metaString = function (commands, options) {
    return new _meta2.default(ezs, commands, options);
};
ezs.metaFile = function (filename, options) {
    return new _meta2.default(ezs, (0, _file2.default)(ezs, filename), options);
};
ezs.parseString = function (commands) {
    return (0, _script2.default)(commands);
};
ezs.fromString = function (commands, options) {
    return new _pipeline2.default(ezs, (0, _script2.default)(commands), options);
};
ezs.parseFile = function (filename) {
    return (0, _script2.default)((0, _file2.default)(ezs, filename));
};
ezs.fromFile = function (filename, options) {
    return new _pipeline2.default(ezs, (0, _script2.default)((0, _file2.default)(ezs, filename)), options);
};
ezs.with = function (selector, name, opts) {
    return new _engine2.default(ezs, _statement2.default.get(ezs, name), opts, selector);
};
ezs.catch = function (func) {
    return new _catcher2.default(func);
};
ezs.toBuffer = function (opts) {
    return new _output2.default(opts);
};
ezs.use = function (plugin) {
    return _statement2.default.set(ezs, plugin);
};
ezs.addPath = function (p) {
    return ezsPath.push(p);
};
ezs.getPath = function () {
    return ezsPath;
};
ezs.command = function (stream, command) {
    var mode = command.mode || 'normal';
    if (!command.name) {
        throw new Error('Bad command : ' + command.name);
    }
    if (mode === 'normal' || mode === 'divisible') {
        return stream.pipe(ezs.all(command.name, command.args));
    }
    if (mode === 'with') {
        return stream.pipe(ezs.with(command.test, command.name, command.args));
    }
    if (mode === 'single') {
        return stream.pipe(ezs.single(command.name, command.args));
    }
    throw new Error('Bad mode: ' + mode);
};
ezs.createServer = function () {
    return _server2.default.createServer(ezs, new _isolatedStore2.default());
};
ezs.createCluster = function () {
    return _server2.default.createCluster(ezs, new _sharedStore2.default());
};

ezs.use(_plugins2.default);

module.exports = ezs;