"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Meta;
var regex = {
    section: /^\s*\[\s*([^\]]*)\s*\]\s*$/,
    param: /^\s*([\w.\-_]+)\s*[=: ]\s*(.*?)\s*$/,
    comment: /^\s*[;#].*$/
};

function Meta(ezs, commands) {
    var lines = commands.split(/\r\n|\r|\n/);
    var result = {};
    var meta = true;
    lines.forEach(function (line) {
        if (!regex.comment.test(line)) {
            if (regex.param.test(line) && meta) {
                var match = line.match(regex.param);
                var paramName = match[1];
                var paramValue = match[2];
                result[paramName] = paramValue;
            } else if (regex.section.test(line)) {
                meta = false;
            }
        }
    });
    return result;
}