'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _statement = require('./statement');

var _statement2 = _interopRequireDefault(_statement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parametersList = {};

function pack() {
    var buf = new Buffer(JSON.stringify(parametersList));
    return buf.toString('base64');
}

function unpack(data) {
    var buf = new Buffer(data, 'base64');
    var txt = buf.toString('ascii');
    return JSON.parse(txt);
}

function get(ezs, pluginName) {
    return parametersList[pluginName] ? parametersList[pluginName] : {};
}

function set(ezs, pluginName, opts) {
    if (!_statement2.default.exists(ezs, pluginName)) {
        throw new Error('Statement does not exists. Register it, before trying to configure it.');
    }
    if ((typeof opts === 'undefined' ? 'undefined' : _typeof(opts)) !== 'object') {
        throw new Error('Statement parameter must be an object.');
    }
    parametersList[pluginName] = opts;
}

function put(ezs, parameters) {
    Object.keys(parameters).forEach(function (key) {
        return set(ezs, key, parameters[key]);
    });
}

exports.default = {
    get: get,
    set: set,
    put: put,
    pack: pack,
    unpack: unpack
};