'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _stream = require('stream');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Pipeline = function (_Duplex) {
    _inherits(Pipeline, _Duplex);

    function Pipeline(ezs, commands, options) {
        _classCallCheck(this, Pipeline);

        var _this = _possibleConstructorReturn(this, (Pipeline.__proto__ || Object.getPrototypeOf(Pipeline)).call(this, _extends({}, options, { objectMode: true })));

        _this.tubin = new _stream.PassThrough({ objectMode: true });
        _this.tubout = _this.tubin;
        (0, _assert2.default)(Array.isArray(commands), 'Pipeline works with an array of commands.');
        var cmds = [].concat(_toConsumableArray(commands));
        cmds.push({
            mode: 'normal',
            name: 'transit',
            args: {}
        });
        _this.tubout = cmds.reduce(ezs.command, _this.tubout);

        _this.on('finish', function () {
            _this.tubin.end();
        });
        _this.tubout.on('data', function (chunk, encoding) {
            _this.push(chunk, encoding);
        });
        _this.tubout.on('finish', function () {
            _this.push(null);
        });
        _this.tubin.on('error', function (e) {
            console.error('Unlikely error on the Pipeline', e);
        });
        _this.tubout.pause();
        return _this;
    }

    _createClass(Pipeline, [{
        key: '_write',
        value: function _write(chunk, encoding, callback) {
            this.tubin.write(chunk, encoding, callback);
        }
    }, {
        key: '_read',
        value: function _read(size) {
            this.lastSize = size;
            if (this.tubout.isPaused()) {
                this.tubout.resume();
            }
        }
    }]);

    return Pipeline;
}(_stream.Duplex);

exports.default = Pipeline;