'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = Script;

var _expression = require('./expression');

var _expression2 = _interopRequireDefault(_expression);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var regex = {
    section: /^\s*\[\s*([^\]]*)\s*\]\s*$/,
    param: /^\s*([\w.\-_]+)\s*[=: ]\s*(.*?)\s*$/,
    comment: /^\s*[;#].*$/
};

var parseOpts = function parseOpts(obj) {
    var res = {};
    if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
        Object.keys(obj).forEach(function (key) {
            var val = obj[key].length === 1 ? obj[key][0] : obj[key];
            console.log(key, ">>"+obj[key]+"<", obj[key].length);
            res[key] = new _expression2.default(val);
        });
    }
    return res;
};

function Script(commands) {
    var lines = commands.split(/\r\n|\r|\n/);
    var result = [];
    console.log('lines', lines)
    lines.forEach(function (line) {
        if (!regex.comment.test(line)) {
            if (regex.param.test(line)) {
                var match = line.match(regex.param);
                var paramName = match[1];
                var paramValue = match[2];
                console.log('paramValue', match, '!')
                var section = result.length > 0 ? result[result.length - 1] : null;
                if (section) {
                    if (!section.args[paramName]) {
                        result[result.length - 1].args[paramName] = [];
                    }
                    result[result.length - 1].args[paramName].push(paramValue);
                }
            } else if (regex.section.test(line)) {
                var matches0 = line.match(regex.section);
                var matches1 = matches0[1].match(/(\w+)\?(\w+)/);
                var matches2 = matches0[1].match(/(\w+)#(\w+)/);
                var mode = 'normal';
                var name = 'debug';
                var test = '';
                if (Array.isArray(matches1)) {
                    name = matches1[1];
                    mode = matches1[2];
                } else if (Array.isArray(matches2)) {
                    mode = 'with';
                    name = matches2[1];
                    test = matches2[2];
                } else {
                    mode = 'normal';
                    name = matches0[1];
                }
                var newSection = {
                    mode: mode,
                    name: name,
                    test: test,
                    args: {}
                };
                result.push(newSection);
            }
        }
    });
    console.log('command', result[0]);
    var cmd = result.map(function (command) {
        return _extends({}, command, {
            args: parseOpts(command.args)
        });
    });
    return cmd;
}
