'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _memored = require('memored');

var _memored2 = _interopRequireDefault(_memored);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SharedStore = function () {
    function SharedStore() {
        _classCallCheck(this, SharedStore);

        _memored2.default.setup({
            purgeInterval: 15000
        });
    }

    _createClass(SharedStore, [{
        key: 'get',
        value: function get(key) {
            return new Promise(function (resolve, reject) {
                if (!key) {
                    return reject(new Error('A undefined key cannot access to the store'));
                }
                return _memored2.default.read(key, function (err, value) {
                    if (err) {
                        return reject(err);
                    }
                    return resolve(value);
                });
            });
        }
    }, {
        key: 'set',
        value: function set(key, value) {
            return new Promise(function (resolve, reject) {
                if (!key) {
                    return reject(new Error('A undefined key cannot access to the store'));
                }
                return _memored2.default.store(key, value, function (err) {
                    if (err) {
                        return reject(err);
                    }
                    return resolve(value);
                });
            });
        }
    }, {
        key: 'all',
        value: function all() {
            return new Promise(function (resolve, reject) {
                return _memored2.default.keys(function (err, value) {
                    if (err) {
                        return reject(err);
                    }
                    return resolve(value);
                });
            });
        }
    }]);

    return SharedStore;
}();

exports.default = SharedStore;