'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = Shell;

var _autocast = require('autocast');

var _autocast2 = _interopRequireDefault(_autocast);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _notevil = require('notevil');

var _notevil2 = _interopRequireDefault(_notevil);

var _mixins = require('./mixins');

var _mixins2 = _interopRequireDefault(_mixins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parse = function parse(context) {
    return function (value) {
        var js = [];
        js.push('_.chain(self).');
        js.push(value.replace(/([)]\s*->\s*)/g, ').'));
        js.push('.value();');
        var code = js.join('');
        var data = (typeof context === 'undefined' ? 'undefined' : _typeof(context)) === 'object' ? _lodash2.default.omitBy(context, _lodash2.default.isFunction) : context;
        _lodash2.default.mixin(_mixins2.default);
        var result = (0, _notevil2.default)(code, {
            _: _lodash2.default,
            self: data
        });
        return result;
    };
};

var analyse = function analyse(context) {
    return function (value) {
        if (Array.isArray(value)) {
            return value.map(analyse(context));
        }
        if (!value || typeof value !== 'string') {
            return value;
        }
        if (value.match(/^[a-zA-Z][a-zA-Z0-9]*[(]/)) {
            return parse(context)(value);
        }
        return (0, _autocast2.default)(value);
    };
};

function Shell(value, context) {
    if (Array.isArray(value)) {
        return value.map(function (item) {
            if (typeof value !== 'function') {
                return item;
            }
            return item(analyse(context));
        });
    }
    if (!value || !value.through) {
        return value;
    }
    return value.through(analyse(context));
}