'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _stream = require('stream');

var _deepObjectDiff = require('deep-object-diff');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Once = function (_Transform) {
    _inherits(Once, _Transform);

    function Once(ezs, mixed, options) {
        _classCallCheck(this, Once);

        var _this = _possibleConstructorReturn(this, (Once.__proto__ || Object.getPrototypeOf(Once)).call(this, { objectMode: true }));

        _this.first = true;
        _this.tubin = new _stream.PassThrough({ objectMode: true });
        _this.tubout = _this.tubin;
        if (Array.isArray(mixed)) {
            _this.tubout = mixed.reduce(ezs.command, _this.tubout);
        } else if (typeof mixed === 'string') {
            _this.tubout = _this.tubin.pipe(ezs(mixed, options));
        }
        _this.on('finish', function () {
            _this.tubin.end();
        });
        _this.on('close', function () {
            _this.tubin.close();
        });
        _this.tubout.pause();
        _this.result = null;
        _this.addedResult = null;
        return _this;
    }

    _createClass(Once, [{
        key: '_transform',
        value: function _transform(chunk, encoding, callback) {
            var _this2 = this;

            if (this.first === true) {
                var oldChunk = Object.assign({}, chunk);
                this.first = false;
                this.tubout.on('data', function (chunk2) {
                    if ((typeof chunk2 === 'undefined' ? 'undefined' : _typeof(chunk2)) === 'object') {
                        if (!_this2.result) {
                            _this2.result = {};
                        }
                        _this2.result = Object.assign(_this2.result, chunk2);
                    } else {
                        if (!_this2.result) {
                            _this2.result = '';
                        }
                        _this2.result += chunk2;
                    }
                }).on('end', function () {
                    _this2.addedResult = (0, _deepObjectDiff.addedDiff)(oldChunk, _this2.result);
                    callback(null, Object.assign(chunk, _this2.addedResult));
                });
                this.tubout.resume();
                this.tubin.write(chunk, encoding, function () {
                    _this2.tubin.end();
                });
            } else {
                callback(null, Object.assign(chunk, this.addedResult));
            }
        }
    }]);

    return Once;
}(_stream.Transform);

exports.default = Once;