# remote-origin-url [![NPM version](https://badge.fury.io/js/remote-origin-url.svg)](http://badge.fury.io/js/remote-origin-url)  [![Build Status](https://travis-ci.org/jonschlinkert/remote-origin-url.svg)](https://travis-ci.org/jonschlinkert/remote-origin-url) 

> Get the git remote origin URL from your local git repository. Remember! A remote origin must exist first!

## Install with [npm](npmjs.org)

```bash
npm i remote-origin-url --save
```
### Install with [bower](https://github.com/bower/bower)

```bash
bower install remote-origin-url --save
```

## Usage

Using the defaults:

```js
var url = require('remote-origin-url');
url(function (err, res) {
  // res => "https://github.com/jonschlinkert/remote-origin-url.git"
})
```

Specify the `cwd` to use:

```js
url(__dirname, function (err, res) {
  // res => "https://github.com/jonschlinkert/remote-origin-url.git"
})
```

### sync

```js
url.sync();
//=> "https://github.com/jonschlinkert/remote-origin-url.git"
```

Specify the `cwd` to use:


```js
url.sync(__dirname);
//=> "https://github.com/jonschlinkert/remote-origin-url.git"
```


## Run tests

Install dev dependencies:

```bash
npm i -d && npm test
```

## Contributing
Pull requests and stars are always welcome. For bugs and feature requests, [please create an issue](https://github.com/jonschlinkert/remote-origin-url/issues)

## Author

**Jon Schlinkert**
 
+ [github/jonschlinkert](https://github.com/jonschlinkert)
+ [twitter/jonschlinkert](http://twitter.com/jonschlinkert) 

## License
Copyright (c) 2015 Jon Schlinkert  
Released under the MIT license

***

_This file was generated by [verb-cli](https://github.com/assemble/verb-cli) on February 27, 2015._
